<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="UTF-8">
<link rel="alternate"
      type="application/rss+xml"
      href="https://blog.winny.tech/rss.xml"
      title="RSS feed for https://blog.winny.tech/"/>
<title>Publishing with org-static-blog</title>

<link href="static/style.css?v=1.13" rel="stylesheet" type="text/css" />
<meta name="viewport" content="width=device-width, initial-scale=1">
</head>
<body>
<div id="preamble" class="status">

<nav>
<div class="flexcontainer">
<div class="smallitem">
<ul class="inline-list">
<li><a href=".">blog.winny.tech</a></li>
<li><a href="https://winny.tech/">About</a></li>
</ul>
</div>
<div class="bigitem">
<ul class="inline-list">
<li><a href="archive.html">Archive</a></li>
<li><a href="tags.html">Tags</a></li>
<li><a href="rss.xml">RSS Feed</a></li>
</ul>
</div>
</div>
</nav>
<hr/>
</div>
<div id="content">
<div class="post-date">11 Jan 2019</div><h1 class="post-title"><a href="2019-01-11-publishing-with-org-static-blog.html">Publishing with org-static-blog</a></h1>

<div id="outline-container-org3a73d42" class="outline-2">
<h2 id="org3a73d42">Criteria</h2>
<div class="outline-text-2" id="text-org3a73d42">
<p>
After reviewing a list of org-mode<sup><a id="fnr.1" class="footref" href="#fn.1">1</a></sup> capable static website generators<sup><a id="fnr.2" class="footref" href="#fn.2">2</a></sup>,
I decided to see if org-static-blog<sup><a id="fnr.3" class="footref" href="#fn.3">3</a></sup> could suffice my simple
needs. My criteria for choosing an org-mode static site generator was:
</p>

<ul class="org-ul">
<li>it must be actively maintained,</li>
<li>it must be simple to set up with customizations,</li>
<li>and it must work with Emacs 26 and later.</li>
</ul>

<p>
This ruled out quite a few right away. I didn't attempt using
org-publish, as it looked like a great deal of configuration to
achieve a minimum viable web-page for this project.
</p>
</div>
</div>

<div id="outline-container-org0f1a008" class="outline-2">
<h2 id="org0f1a008">Configuration of <code>org-static-blog</code></h2>
<div class="outline-text-2" id="text-org0f1a008">
<p>
Following the org-static-blog README documentation, it is very
straight forward to get a minimal viable website generated. I added
the following to my <code>init.el</code>:
</p>

<div class="org-src-container">
<pre class="src src-elisp">(add-to-list 'auto-mode-alist (cons (concat org-static-blog-posts-directory <span style="color: #61CE3C;">".*\\.org\\'"</span>) 'org-static-blog-mode))
(<span style="color: #4c83ff;">setq</span> org-static-blog-publish-title <span style="color: #61CE3C;">"blog.winny.tech"</span>)
(<span style="color: #4c83ff;">setq</span> org-static-blog-publish-url <span style="color: #61CE3C;">"https://blog.winny.tech/"</span>)
(<span style="color: #4c83ff;">setq</span> org-static-blog-publish-directory <span style="color: #61CE3C;">"~/projects/blog/"</span>)
(<span style="color: #4c83ff;">setq</span> org-static-blog-posts-directory <span style="color: #61CE3C;">"~/projects/blog/posts/"</span>)
(<span style="color: #4c83ff;">setq</span> org-static-blog-drafts-directory <span style="color: #61CE3C;">"~/projects/blog/drafts/"</span>)
(<span style="color: #4c83ff;">setq</span> org-static-blog-enable-tags t)

(<span style="color: #4c83ff;">setq</span> org-static-blog-page-header
      <span style="color: #61CE3C;">"</span>
<span style="color: #61CE3C;">&lt;link href=\"static/style.css\" rel=\"stylesheet\" type=\"text/css\" /&gt;</span>
<span style="color: #61CE3C;">"</span>)
</pre>
</div>

<p>
I opted to <code>setq</code> all the configuration variables; I will likely
switch to using <code>M-x customize-group RET org-static-blog RET</code> in the
future however. It's a better experience.
</p>

<p>
Then I simply create a new post with
<code>M-x org-static-blog-create-new-post RET &lt;TITLE&gt; RET</code>, edit the
buffer, save it, then run <code>M-x org-static-blog-publish RET</code>.
I also added some styling to my <code>style.css</code><sup><a id="fnr.4" class="footref" href="#fn.4">4</a></sup> based off the Tachyons CSS
framework<sup><a id="fnr.5" class="footref" href="#fn.5">5</a></sup>. I had previously used Bootstrap<sup><a id="fnr.6" class="footref" href="#fn.6">6</a></sup> for styling but was hoping
to avoid adding framework and other extra tooling that shouldn't
be necessary to generate a simple site like this one.
</p>
</div>
</div>

<div id="outline-container-org476ad59" class="outline-2">
<h2 id="org476ad59">Deploying with Caddy and GitHub</h2>
<div class="outline-text-2" id="text-org476ad59">
<p>
I am a fan of the Caddy<sup><a id="fnr.7" class="footref" href="#fn.7">7</a></sup> web server which offers automatic HTTPS
via LetsEncrypt with only a few lines of configuration. In addition
Caddy has a plugin named git which offers the ability to
automatically deploy content from git repositories with webhook
support. To deploy the following steps are taken:
</p>

<ol class="org-ol">
<li><code>M-x org-static-blog-publish RET</code> from Emacs to regenerate the
static site,</li>
<li>commit the changes in git,</li>
<li>and finally push the git branch to GitHub.</li>
</ol>

<p>
After these steps, GitHub automatically sends a HTTP POST request to my Caddy
server with information about the new git commits and Caddy pulls the
git repository. If everything went well and the webhook successfully
fired, the website is now deployed.
</p>
</div>

<div id="outline-container-org5145981" class="outline-3">
<h3 id="org5145981">Server Configuration</h3>
<div class="outline-text-3" id="text-org5145981">
<p>
I switched most of my personal internet-related services to Docker<sup><a id="fnr.8" class="footref" href="#fn.8">8</a></sup> in
conjunction with <code>docker-compose</code><sup><a id="fnr.9" class="footref" href="#fn.9">9</a></sup> last year. The main rationale
is I can move my configuration without dealing with systems package
versions.  I already had Caddy set up,
so it was as simple as adding this to my <code>Caddyfile</code>:
</p>

<div class="org-src-container">
<pre class="src src-conf"><span style="color: #afd8af;">blog.winny.tech</span> {
        root /srv/www/blog.winny.tech
        gzip
        log /logs/blog.winny.tech.log
        git https://github.com/winny-/blog.winny.tech {
                hook /webhook top-secret-password-redacted
        }
}
</pre>
</div>

<p>
The relevant lines of my <code>docker-compose.yml</code> looks like this:
</p>

<div class="org-src-container">
<pre class="src src-yaml"><span style="color: #ff69b4;">version</span>: <span style="color: #61CE3C;">"2.1"</span>
<span style="color: #ff69b4;">services</span>:
  <span style="color: #ff69b4;">web</span>:
    <span style="color: #ff69b4;">image</span>: abiosoft/caddy:no-stats
    <span style="color: #ff69b4;">ports</span>:  <span style="color: #8B8989; font-style: italic;"># </span><span style="color: #8B8989; font-style: italic;">Expose the webserver ports to the internet</span>
      - <span style="color: #61CE3C;">"80:80"</span>
      - <span style="color: #61CE3C;">"443:443"</span>
    <span style="color: #ff69b4;">environment</span>:
      <span style="color: #8B8989; font-style: italic;"># </span><span style="color: #8B8989; font-style: italic;">This is where caddy places certs after ACME negotiation.</span>
      <span style="color: #ff69b4;">CADDYPATH</span>: <span style="color: #61CE3C;">"/etc/caddycerts"</span>
      <span style="color: #ff69b4;">ACME_AGREE</span>: <span style="color: #61CE3C;">"true"</span>
    <span style="color: #ff69b4;">volumes</span>:
      - /srv/caddy/certs:/etc/caddycerts
      - /srv/caddy/Caddyfile:/etc/Caddyfile  <span style="color: #8B8989; font-style: italic;"># </span><span style="color: #8B8989; font-style: italic;">Configuration</span>
      - /srv/www:/srv/www  <span style="color: #8B8989; font-style: italic;"># </span><span style="color: #8B8989; font-style: italic;">the websites</span>
      - /srv/caddy/logs:/logs
</pre>
</div>

<p>
A keen <code>docker-compose</code>-savy reader will notice I did not specify a
<code>restart: always</code> entry. I had Caddy configured to always restart,
however, when requesting new HTTPS certificates from LetsEncrypt, there
is a tendency to misconfigure the domain configuration or Caddyfile,
and if Caddy requests too many HTTPS certificates in a short amount of
time, LetsEcrypt will rate-limit my future requests. Usually this is
only requires an hour or two of waiting, but is frustrating to deal
with when trying to fix my configuration. Instead I rather Caddy
exit after failing to activate all the domains and fix my
configuration first.
</p>
</div>
</div>

<div id="outline-container-org4f516bc" class="outline-3">
<h3 id="org4f516bc">GitHub Configuration</h3>
<div class="outline-text-3" id="text-org4f516bc">
<p>
Simply create the GitHub repository, then add a webhook. It is
important to note the webhook <i>must</i> send a JSON payload. By default a
newly created webhook will send a <code>application/x-www-form-urlencoded</code>
payload and will not work.
</p>
</div>
</div>
</div>

<div id="outline-container-org8aa0991" class="outline-2">
<h2 id="org8aa0991">Conclusion</h2>
<div class="outline-text-2" id="text-org8aa0991">
<p>
With this simple setup I can write posts. I can easily move the
configuration to a new host at will. In addition my setup does not
depend on future use of GitHub as GitLab, Gogs, and other git hosts
offer webhook support in the same way. Most importantly, I can author
org-mode files and have a better balance between features and ease of
use than what markdown offers.
</p>

<p>
Web dev is one of my least
favorite programming exercises. Between all the testing necessary to
ensure a simple site works across many platforms, the trend to use a
very complex system such as webpack and many other tools to produce
simple websites, and the perpetual flux-and-flow between vendors only
partially implementing good features, web dev just doesn't do it for
me. Hence, I am very pleased how simple this project turned out to
be.
</p>
</div>
</div>
<div id="footnotes">
<h2 class="footnotes">Footnotes: </h2>
<div id="text-footnotes">

<div class="footdef"><sup><a id="fn.1" class="footnum" href="#fnr.1">1</a></sup> <div class="footpara"><p class="footpara">
<a href="https://orgmode.org/">org-mode homepage</a>
</p></div></div>

<div class="footdef"><sup><a id="fn.2" class="footnum" href="#fnr.2">2</a></sup> <div class="footpara"><p class="footpara">
<a href="https://orgmode.org/worg/org-blog-wiki.html">Blogs and Wikis with Org</a>
</p></div></div>

<div class="footdef"><sup><a id="fn.3" class="footnum" href="#fnr.3">3</a></sup> <div class="footpara"><p class="footpara">
<a href="https://github.com/bastibe/org-static-blog/">org-static-blog on GitHub</a>
</p></div></div>

<div class="footdef"><sup><a id="fn.4" class="footnum" href="#fnr.4">4</a></sup> <div class="footpara"><p class="footpara">
<a href="static/style.css"><code>static/style.css</code></a>
</p></div></div>

<div class="footdef"><sup><a id="fn.5" class="footnum" href="#fnr.5">5</a></sup> <div class="footpara"><p class="footpara">
<a href="http://tachyons.io/">Tachyons homepage</a>
</p></div></div>

<div class="footdef"><sup><a id="fn.6" class="footnum" href="#fnr.6">6</a></sup> <div class="footpara"><p class="footpara">
<a href="https://getbootstrap.com/">Bootstrap framework homepage</a>
</p></div></div>

<div class="footdef"><sup><a id="fn.7" class="footnum" href="#fnr.7">7</a></sup> <div class="footpara"><p class="footpara">
<a href="https://caddyserver.com/">Caddy webserver homepage</a>
</p></div></div>

<div class="footdef"><sup><a id="fn.8" class="footnum" href="#fnr.8">8</a></sup> <div class="footpara"><p class="footpara">
<a href="https://docs.docker.com/engine/">Docker Engine homepage</a>
</p></div></div>

<div class="footdef"><sup><a id="fn.9" class="footnum" href="#fnr.9">9</a></sup> <div class="footpara"><p class="footpara">
<a href="https://docs.docker.com/compose/overview/"><code>docker-compose</code> homepage</a>
</p></div></div>


</div>
</div><div class="taglist"><a href="tags.html">Tags</a>: <a href="tag-computing.html">computing</a> </div></div>
<div id="postamble" class="status">
<hr/>
<ul class="inline-list interpunct">
<li>Powered by <a href="https://github.com/bastibe/org-static-blog">org-static-blog</a></li>
<li>Like what I do? <a href="https://www.buymeacoffee.com/winny">Buy me a Coffee</a></li>
</ul>
<p>© Winston Weinert (winny) — <a href="https://creativecommons.org/licenses/by-sa/4.0/legalcode">CC-BY-SA-4.0</a></p>
</div>
</body>
</html>
